#!/bin/bash

app="siap-server"
versao=$(sed -nE 's/^\s*"version": "(.*?)",$/\1/p' package.json)
tag="v$versao"

printf "\n"
printf "#########################\n"
printf "# Compilando $app-$tag  #\n"
printf "#########################\n"
printf "\n\n"


docker build --file compose/production/siap-server/Dockerfile --tag "$app":"$tag" .
mkdir -p _build
docker save "$app":"$tag" | gzip -c > ./_build/"$app"-"$tag".tar.gz
tar czf ./_build/"$app"-"$tag".src.tar.gz doc/ public/ src/ compose/ .envs/ .dockerignore build.sh package-lock.json package.json README.md local.yml production.yml

printf "\n"
printf "#############################################\n"
printf "# Gerada imagem para $app:$tag em ./_build/ #\n"
printf "#############################################\n"
printf "\n\n"

ls -lah ./_build/