--
-- PERFIL PUBLICO
--

;WITH PERMISSAO_PERFIL_PUBLICO(ID_ITEM)
AS
(
    SELECT I.ID_ITEM
	FROM SISPESQUISA.sispesquisa.ITENS I
		INNER JOIN SISPESQUISA.sispesquisa.SECOES S ON (I.ID_SECAO = S.ID_SECAO)
	WHERE S.DESCRICAO = 'PESQUISA' AND I.DESCRICAO = 'PESSOA'
)

INSERT INTO SISPESQUISA.USUARIO_ITENS (ID_USUARIO,ID_ITEM)

SELECT U.id, P.ID_ITEM	
FROM SISPESQUISA.sispesquisa.usuario U 
	CROSS JOIN PERMISSAO_PERFIL_PUBLICO P
WHERE U.perfil='publico'
	AND NOT EXISTS (SELECT UI.ID_USUARIO, UI.ID_ITEM FROM SISPESQUISA.USUARIO_ITENS UI WHERE UI.ID_USUARIO = U.id AND UI.ID_ITEM = P.ID_ITEM)

--
-- PERFIL PRIVADO
--
	
;WITH PERMISSAO_PERFIL_PRIVADO(ID_ITEM)
AS
(
    SELECT I.ID_ITEM
	FROM SISPESQUISA.sispesquisa.ITENS I
		INNER JOIN SISPESQUISA.sispesquisa.SECOES S ON (I.ID_SECAO = S.ID_SECAO)
	WHERE S.DESCRICAO = 'PESQUISA'

	UNION

	SELECT I.ID_ITEM
	FROM SISPESQUISA.sispesquisa.ITENS I
		INNER JOIN SISPESQUISA.sispesquisa.SECOES S ON (I.ID_SECAO = S.ID_SECAO)
	WHERE S.DESCRICAO = 'APPS' AND
	(
		I.DESCRICAO = 'RELACIONAMENTOS' OR
		I.DESCRICAO = 'RELATORIO INTEGRADO' OR
		I.DESCRICAO = 'ERB TRACKER' OR
		I.DESCRICAO = 'TIPORANK'
	)
)

INSERT INTO SISPESQUISA.USUARIO_ITENS (ID_USUARIO,ID_ITEM)

SELECT U.id, P.ID_ITEM	
FROM SISPESQUISA.sispesquisa.usuario U 
	CROSS JOIN PERMISSAO_PERFIL_PRIVADO P
WHERE U.perfil='privado'
	AND NOT EXISTS (SELECT UI.ID_USUARIO, UI.ID_ITEM FROM SISPESQUISA.USUARIO_ITENS UI WHERE UI.ID_USUARIO = U.id AND UI.ID_ITEM = P.ID_ITEM)
	
		
--
-- PERFIL MEMBRO
--
	
;WITH PERMISSAO_PERFIL_MEMBRO(ID_ITEM)
AS
(
    SELECT I.ID_ITEM
	FROM SISPESQUISA.sispesquisa.ITENS I
		INNER JOIN SISPESQUISA.sispesquisa.SECOES S ON (I.ID_SECAO = S.ID_SECAO)
	WHERE S.DESCRICAO = 'PESQUISA'

	UNION

	SELECT I.ID_ITEM
	FROM SISPESQUISA.sispesquisa.ITENS I
		INNER JOIN SISPESQUISA.sispesquisa.SECOES S ON (I.ID_SECAO = S.ID_SECAO)
	WHERE S.DESCRICAO = 'APPS' AND
	(
		I.DESCRICAO = 'INTEGRA' OR
		I.DESCRICAO = 'DNA' OR
		I.DESCRICAO = 'RELACIONAMENTOS' OR
		I.DESCRICAO = 'RELATORIO INTEGRADO' OR
		I.DESCRICAO = 'ERB TRACKER' OR
		I.DESCRICAO = 'TIPORANK'
	)
)

INSERT INTO SISPESQUISA.USUARIO_ITENS (ID_USUARIO,ID_ITEM)

SELECT U.id, P.ID_ITEM	
FROM SISPESQUISA.sispesquisa.usuario U 
	CROSS JOIN PERMISSAO_PERFIL_MEMBRO P
WHERE U.membro = 'S'
	AND NOT EXISTS (SELECT UI.ID_USUARIO, UI.ID_ITEM FROM SISPESQUISA.USUARIO_ITENS UI WHERE UI.ID_USUARIO = U.id AND UI.ID_ITEM = P.ID_ITEM)

		
--
-- PERFIL OPERACOES
--
	
;WITH PERMISSAO_PERFIL_OPERACOES(ID_ITEM)
AS
(
    SELECT I.ID_ITEM
	FROM SISPESQUISA.sispesquisa.ITENS I
		INNER JOIN SISPESQUISA.sispesquisa.SECOES S ON (I.ID_SECAO = S.ID_SECAO)
	WHERE S.DESCRICAO = 'PESQUISA'

	UNION

	SELECT I.ID_ITEM
	FROM SISPESQUISA.sispesquisa.ITENS I
		INNER JOIN SISPESQUISA.sispesquisa.SECOES S ON (I.ID_SECAO = S.ID_SECAO)
	WHERE S.DESCRICAO = 'APPS' AND
	(
		I.DESCRICAO = 'CACA FANTASMAS' OR		
		I.DESCRICAO = 'MAPA DE CONSUMO' OR
		I.DESCRICAO = 'RELACIONAMENTOS' OR
		I.DESCRICAO = 'RELATORIO INTEGRADO' OR
		I.DESCRICAO = 'ERB TRACKER' OR
		I.DESCRICAO = 'TIPORANK'
	)

	UNION

	SELECT I.ID_ITEM
	FROM SISPESQUISA.sispesquisa.ITENS I
		INNER JOIN SISPESQUISA.sispesquisa.SECOES S ON (I.ID_SECAO = S.ID_SECAO)
	WHERE S.DESCRICAO = 'OPERACOES' AND
	(
		I.DESCRICAO = 'CADASTRO DE ENDERECO' OR		
		I.DESCRICAO = 'CADASTRO DE TELEFONE'
	)
)

INSERT INTO SISPESQUISA.USUARIO_ITENS (ID_USUARIO,ID_ITEM)

SELECT U.id, P.ID_ITEM	
FROM SISPESQUISA.sispesquisa.usuario U 
	CROSS JOIN PERMISSAO_PERFIL_OPERACOES P
WHERE U.Operacoes = 1
	AND NOT EXISTS (SELECT UI.ID_USUARIO, UI.ID_ITEM FROM SISPESQUISA.USUARIO_ITENS UI WHERE UI.ID_USUARIO = U.id AND UI.ID_ITEM = P.ID_ITEM)
		
--
-- PERFIL ADMIN
--
	
;WITH PERMISSAO_PERFIL_ADMIN(ID_ITEM)
AS
(
    SELECT I.ID_ITEM
	FROM SISPESQUISA.sispesquisa.ITENS I
		INNER JOIN SISPESQUISA.sispesquisa.SECOES S ON (I.ID_SECAO = S.ID_SECAO)	
)

INSERT INTO SISPESQUISA.USUARIO_ITENS (ID_USUARIO,ID_ITEM)

SELECT U.id, P.ID_ITEM	
FROM SISPESQUISA.sispesquisa.usuario U 
	CROSS JOIN PERMISSAO_PERFIL_ADMIN P
WHERE U.administrador = 'S'
	AND NOT EXISTS (SELECT UI.ID_USUARIO, UI.ID_ITEM FROM SISPESQUISA.USUARIO_ITENS UI WHERE UI.ID_USUARIO = U.id AND UI.ID_ITEM = P.ID_ITEM)

