import * as _ from 'underscore';
import * as rp from 'request-promise-native';

import * as utilsModel from './../../models/utils/utils.model';
import * as nepotismoModel from './../../models/nepotismo.model';

import {
    filtraNaoEncontrados,
} from './../../utils';

export let procuraOrgaoSagresMunicipalEstadual = function (orgao: string) {
    return Promise.all([
        utilsModel.getOrgaoSagresMunicipalEstadual(orgao),
    ])
        .then(tipologias => filtraNaoEncontrados(tipologias))
}

export let procuraNepotismoUgestora = function (ugestora: string, esfera: string, ano: string) {
    return Promise.all([
        nepotismoModel.getNepotismoUgestoraEsferaAno(ugestora, esfera, ano),
    ])
        .then(tipologias => filtraNaoEncontrados(tipologias))
}

export let procuraNepotismoCPF = function (cpf: string, ano: string) {
    return Promise.all([
        nepotismoModel.getNepotismoCPFAno(cpf, ano)
    ])
        .then(tipologias => filtraNaoEncontrados(tipologias))
}
