import { Request, Response } from 'express';

import * as tipologiaModel from './../../models/tipologia.model';
import * as utilsModel from './../../models/utils/utils.model';

import { Log } from './../../schemas/log.schema';
import { Pessoa } from './../../models/schemas';
import {
    trataRequisicaNome,
    toTextSearch,
    agrupaEFiltraDuplicados,
    filtraNaoEncontrados,
    desagrupa,
    print,
    flat,
    getId_Token,
    registraNaoEncontrados
} from './../../utils';

import {
    API_CODES,
    API_CONFIG,
    LOG_CODES,
    LOG_MSGS
} from './../../config';


export let procuraTipologiasMunicipioUF = function (uf: string, municipio: string) {
    const dados = { uf: uf, municipio: municipio };

    return Promise.all([
        tipologiaModel.getTipologiaPJSimplificadoUFMunicipio_Tipologias(dados),
        //tipologiaModel.getTipologiaPFSimplificadoUFMunicipio_Tipologias(dados),
    ])
        .then(tipologias => filtraNaoEncontrados(tipologias))
}

export let procuraMunicioUF = function (uf: string, municipioParcial: string) {
    
    return Promise.all([
        utilsModel.getMunicipioUF_ReceitaNovo_UFMunicipio(uf, municipioParcial),
    ])
        .then(tipologias => filtraNaoEncontrados(tipologias))
}
