import { API_CONFIG } from "./config";
import { generateHeapDumpAndStats } from "./utils";

const Memwatch = require('node-memwatch');
const Util     = require('util');
/**
 *
 */
export let traceMem = function () {
  /**
   * Check for memory leaks
   */
  let hd = null;
  Memwatch.on('leak', (info) => {
    const id = (process.env.pm_id) ? process.env.pm_id : ((process.env.id) ? process.env.id : 0);

    console.error(`\n\n${id} - Memwatch::leak`);
    console.error(info);
    console.error('\n\n');

    generateHeapDumpAndStats();

    if (!hd) {
      hd = new Memwatch.HeapDiff();
    }
    else {
      const id = (process.env.pm_id) ? process.env.pm_id : ((process.env.id) ? process.env.id : 0);
      const diff = hd.end();

      console.error(`\n\n${id} - Memwatch::leak`);
      console.error(Util.inspect(diff, { showHidden: true, depth: null, colors: true}));
      console.error('\n\n');

      hd = null;
    }
  });

  Memwatch.on('stats', (stats) => {
    const id = (process.env.pm_id) ? process.env.pm_id : ((process.env.id) ? process.env.id : 0);

    console.log(`\n\n${id} - Memwatch::stats`);
    console.log(Util.inspect(stats, { showHidden: true, depth: null, colors: true}));
    console.log('\n\n');
  });
}
