import * as mssql from 'mssql';

import { connection }  from '../services/db.service';
import { Pessoa } from './schemas';
import { MODEL_PRIORITY } from './../config';
import {
    trataResultado,
    resultNotFound,
    resultFound,
    logErroBuscaBD,
    resultFoundRaw
} from './../utils';

const fonte   = MODEL_PRIORITY['risco'].fonte;
const rank    = MODEL_PRIORITY['risco'].rank;
const grupo   = MODEL_PRIORITY['risco'].grupo;

export let getQuestao_Sispesquisa_PerguntaResposta = function (cpf: string){

    return new Promise((resolve, reject) => {
        const shuffleArray = arr => arr.sort(() => Math.random() - 0.5);
        const data = [
            { 
                id_pergunta: 1,
                pergunta: 'Lorem ipsum porta lectus enim taciti ultricies imperdiet venenatis habitasse, tellus in duis condimentum sapien commodo pulvinar fringilla, imperdiet cursus suspendisse praesent tellus per ut sagittis. vulputate venenatis odio suscipit primis malesuada porttitor maecenas proin, eros dictumst in senectus elit ac aptent, varius risus in est praesent quisque morbi. fusce nam nisi nisl velit nullam a neque purus scelerisque blandit, vulputate adipiscing felis auctor tristique nam ornare consectetur enim malesuada, ante molestie lobortis dolor lacinia vivamus semper euismod diam', 
                respostas: [
                    { id_resposta: 1, alternativa: 'Sim', temComplemento: false},
                    { id_resposta: 2, alternativa: 'Não', temComplemento: true},
                ] 
            },
            { 
                id_pergunta: 2,
                pergunta: 'Conubia est congue semper sed luctus conubia nibh neque vestibulum, inceptos vestibulum phasellus nam sodales dictum blandit dolor convallis class, sagittis nibh et inceptos posuere fusce erat neque. tincidunt dictumst elit semper consectetur consequat nunc praesent felis urna sagittis, viverra odio est enim eros lacinia ornare auctor luctus enim, vitae pharetra fermentum in iaculis nisl torquent quis turpis ', 
                respostas: [
                    { id_resposta: 3, alternativa: 'Sim', temComplemento: false},
                    { id_resposta: 4, alternativa: 'Não', temComplemento: false},
                    { id_resposta: 5, alternativa: 'Não sei', temComplemento: true},
                ] 
            },
            { 
                id_pergunta: 3,
                pergunta: 'Proin rhoncus praesent imperdiet volutpat praesent vitae imperdiet cras vehicula potenti ante, ultricies id posuere justo pretium blandit litora mauris dapibus ante, euismod fringilla risus sagittis viverra metus ornare litora porta risus.', 
                respostas: [
                    { id_resposta: 6, alternativa: 'Sim', temComplemento: false},
                    { id_resposta: 7, alternativa: 'Não', temComplemento: false},
                ] 
            },
            { 
                id_pergunta: 4,
                pergunta: 'Vulputate dui facilisis primis luctus vitae accumsan aliquam fames vel, nostra sollicitudin etiam justo lacinia cubilia lectus ornare, eros aliquet volutpat at sit elit vel ut. dolor sociosqu cubilia molestie ut adipiscing vestibulum congue blandit,', 
                respostas: [
                    { id_resposta: 8, alternativa: 'Sim', temComplemento: false},
                    { id_resposta: 9, alternativa: 'Não', temComplemento: false},
                    { id_resposta: 10, alternativa: 'Talvez', temComplemento: false},
                ] 
            },
            { 
                id_pergunta: 5,
                pergunta: 'vulputate adipiscing felis auctor tristique nam ornare consectetur enim malesuada, ante molestie lobortis dolor lacinia vivamus semper euismod diam. augue adipiscing vestibulum lectus nostra vestibulum fames faucibus aenean, torquent nisi donec quisque mi sed phasellus, consequat adipiscing varius litora himenaeos ornare ullamcorper. ', 
                respostas: [
                    { id_resposta: 11, alternativa: 'Sim', temComplemento: false},
                    { id_resposta: 12, alternativa: 'Não', temComplemento: false},
                ] 
            }
        ];
       
        resolve(resultFoundRaw(shuffleArray(data), fonte, rank, grupo));
    });

};
