import { getControleAcessoAppsUsuario_Sispesquisa_Usuario, getControleAcessoPesquisaUsuario_Sispesquisa_Usuario, getControleAcessoAnaliseUsuario_Sispesquisa_Usuario, getControleAcessoOperacoesUsuario_Sispesquisa_Usuario } from "./usuario.model";

export class Usuario{
    id?:             number;
    nome?:           string;
    login?:           string;
    email?:          string;
    ativo?:          string;

    administrador?:  string;
    ad?:             string;
    perfil?:         string;
    senha?:          string;
    proximoLogon?:   string;

    processo?:       string;
    membro?:         string;
    operacoes?:      number;
    grupo?:          string;
    idCadastrador?:  number;

    constructor(obj){
        if (obj.id)
            this.id            = obj.id;
        if (obj.nome)
            this.nome          = obj.nome;
        if (obj.login)
            this.login         = obj.login;
        if (obj.email)
            this.email         = obj.email;
        if (obj.ativo)
            this.ativo         = obj.ativo;

        if (obj.administrador)
            this.administrador = obj.administrador;
        if (obj.AD)
            this.ad            = obj.AD;
        if (obj.perfil)
            this.perfil        = obj.perfil;
        if (obj.senha)
            this.senha         = obj.senha;
        if (obj.proximo_logon)
            this.proximoLogon  = obj.proximo_logon;

        if (obj.processo)
            this.processo      = obj.processo;
        if (obj.membro)
            this.membro        = obj.membro;
        if (obj.id_cadastrador)
            this.idCadastrador = obj.id_cadastrador;
        if (obj.GRUPO)
            this.grupo         = obj.GRUPO;

        if (obj.operacoes || obj.Operacoes)
            this.operacoes = obj.operacoes || obj.Operacoes;
    }

    existe(){
        if (Object.keys(this).length > 0)
            return true;
        else
            return false;
    }

    estaAtivo(){
        if (this.ativo === "S")
            return true;
        else
            return false;
    }

    getAcesso() {
        return Promise.all([getControleAcessoPesquisaUsuario_Sispesquisa_Usuario(this.id),
                            getControleAcessoAppsUsuario_Sispesquisa_Usuario(this.id),
                            getControleAcessoAnaliseUsuario_Sispesquisa_Usuario(this.id),
                            getControleAcessoOperacoesUsuario_Sispesquisa_Usuario(this.id)])
            .then(r => {

                return Object.assign(r[0], r[1], r[2], r[3])
            })
        // const pesquisa  = await getControleAcessoPesquisaUsuario_Sispesquisa_Usuario(this.id);
        // const apps      = await getControleAcessoAppsUsuario_Sispesquisa_Usuario(this.id);
        // const analise   = await getControleAcessoAnaliseUsuario_Sispesquisa_Usuario(this.id);
        // const operacoes = await getControleAcessoOperacoesUsuario_Sispesquisa_Usuario(this.id);
        
        // const r = Object.assign(pesquisa, apps, analise, operacoes);
        // console.log(r);
        
        // return Object.assign(pesquisa, apps, analise, operacoes);
    }

    toToken(){
        return this.getAcesso()
            .then(acesso => {

                let token: any = {
                    nome: this.nome,
                    perfil: this.meuPerfil(),
                    necessita_processo: (this.administrador === 'S') ? 'N' : this.processo,
                    id: this.id,
                    acesso: acesso
                }

                if (this.membro === 'S') {
                    token.membro = true;
                }

                if (this.grupo) {
                    token.grupo = this.grupo;
                }

                if (this.operacoes) {
                    token.operacoes = true;
                }

                if (this.proximoLogon === 'S' && this.ad === 'LOCAL') {
                    token.troca_senha = 'S';
                }

                return token;
            })
        // const acesso = await this.getAcesso();
    }

    meuPerfil(){
        if (this.administrador === 'S'){
            return 'admin';
        }else {
            return this.perfil;
        }
    }
}

export class ControleAcesso{
    acesso:   {pesquisa: object, apps: object};

    pesquisa: object;
    apps:     object;

    constructor(pesquisa, apps){
        if (pesquisa)
            this.acesso.pesquisa = pesquisa;
        if (apps)
            this.acesso.apps = apps;
    }
}

export class CadastroUsuario{
    id?:             number;
    nome?:           string;
    nacionalidade?:  string;
    cpf?:            string;
    identidade?:     string;

    orgaoEmissor?:   string;    
    ufOrgaoEmissor?: string;
    matricula?:      string;
    titularidade?:   string;
    promotoria?:     string;

    email?:          string;
    telefone?:       string;
    dataCadastro?:   string;
    ativado?:        string;
    
    constructor(obj){
        if (obj.id)
            this.id            = obj.id;
        if (obj.nome)
            this.nome          = obj.nome;
        if (obj.nacionalidade)
            this.nacionalidade = obj.nacionalidade;
        if (obj.cpf)
            this.cpf           = obj.cpf;
        if (obj.identidade)
            this.identidade    =  obj.identidade;

        if (obj.orgaoEmissor)
            this.orgaoEmissor   = obj.org_emissor;
        if (obj.ufOrgaoEmissor)
            this.ufOrgaoEmissor = obj.uf_orgao_emissor;
        if (obj.matricula)
            this.matricula      = obj.matricula;
        if (obj.titularidade)
            this.titularidade   = obj.titularidade;
        if (obj.promotoria)
            this.promotoria     = obj.promotoria;

        if (obj.email)
            this.email        = obj.email;
        if (obj.telefone)
            this.telefone     = obj.telefone;
        if (obj.dataCadastro)
            this.dataCadastro = obj.dt_cadastro;
        if (obj.ativado)
            this.ativado      = obj.ativado;
    }

    existe(){
        if (Object.keys(this).length > 0)
            return true;
        else
            return false;
    }
}

// export class Pessoa{

//       constructor(
//           public cpf: string,
//           public nome: string,
//           public nomeMae: string,
//           public nomePai: string,
//           public tituloEleitor: string,
//           public dataNascimento: Date,
//           public situacaoCadastral: string,

//           public residenteExterior: string,
//           public nomePaisExterior: string,
//           public sexo: string,
//           public anoObito: Date,

//           public estrangeiro: string,
//           public dataAtualizacao: Date,
//           public fonte: string
//       ){}

// }

export interface Pessoa{

    cpf?:               string,
    nome?:              string,
    nomeMae?:           string,
    nomePai?:           string,
    tituloEleitor?:     string,
    dataNascimento?:    Date,
    situacaoCadastral?: string,

    residenteExterior?: string,
    nomePaisExterior?:  string,
    sexo?:              string,
    anoObito?:          Date,

    estrangeiro?:       string,
    dataAtualizacao?:   Date,
    fonte?:             string,

    Codigo?:            string,
    rg?:                string,
    dataExpedicao?:     Date,
    naturalidade?:      string,
    UFNaturalidade?:    string,

    logradouro?:        string,
    numero?:            string,
    bairro?:            string,
    municipio?:            string,
    uf?:                string,
    cep?:               string,
    telefone?:          string
}

export interface Empresa{

    cnpj?:              string,
    nomeFantasia?:      string,
    razaoSocial?:       string,
    dtInicioAtividade?: Date,
    
    tipoLogradouro?:    string,
    logradouro?:        string,
    numero?:            string, 
    complemento?:       string,
    cep?:               string,
    municipio?:         string, 
    uf?:                string, 

    cpfResponsavel?:    string, 
    nomeResponsavel?:   string,
    descResponsavel?:   string,

    ddd?:               string, 
    telefone?:          string, 
    ddd2?:              string, 
    telefone2?:         string, 
    dddFax?:            string, 
    telefoneFax?:       string

}