-- TIPOLOGIA
--
-- Lista os servidores que receberam pagamentos pela folha do órgão após sua 
-- data de óbito.

DECLARE @DT_INICIAL CHAR(8), @DT_FINAL CHAR(8), @UGESTORA INT, @CPF CHAR(11)

SET @DT_INICIAL = '20141101'
SET @DT_FINAL   = '20170201'
SET @UGESTORA   = '201095'

SELECT *
FROM (
    SELECT
        PF.Nome as nome
        ,O.Falecido as nomeFalecido
        ,FP.cd_CPF AS cpf
        ,FP.nu_Matricula AS matricula
        ,CAR.de_Cargo AS cargo
        ,FP.MESANO_ORDENADO AS mesAno
        ,O.Obito as dataObito
        ,DATEDIFF(M,O.OBITO,FP.MESANO_ORDENADO + '01') AS mesesFalecido
        ,CAR.de_TipoCargo AS natureza
        ,SUM(
            CASE
                WHEN FP.tp_Lancamento = 0 THEN FP.vl_Lancamento
                ELSE 0
            END
        ) AS remuneracaoBruta
        ,SUM(
            CASE
                WHEN FP.tp_Lancamento = 1 THEN FP.vl_Lancamento
                ELSE 0
            END
        ) AS descontos
        ,SUM(
            CASE
                WHEN FP.tp_Lancamento = 0 THEN FP.vl_Lancamento
                ELSE 0
            END
        )
        -
        SUM(
            CASE
                WHEN FP.tp_Lancamento = 1 THEN FP.vl_Lancamento
                ELSE 0
            END
        )
        AS remuneracaoLiquida
        ,'${nomenclaturas['fp_sisobi']}' as tipologia

    FROM SAGRES_MUNICIPAL.dbo.FolhaPagamento_N FP
        LEFT OUTER JOIN ReceitaNovo.dbo.PessoaFisica PF ON (PF.CPF = FP.cd_CPF)
        LEFT OUTER JOIN Sisobi.dbo.Obito O ON (FP.cd_CPF = O.CPF_RF)

        CROSS APPLY(
            SELECT TOP 1 C.DE_CARGO, TC.DE_TIPOCARGO
            FROM SAGRES_MUNICIPAL.dbo.Cargos C
            INNER JOIN SAGRES_MUNICIPAL.dbo.Tipo_Cargo TC ON (TC.TP_CARGO = C.TP_CARGO)
            WHERE (C.CD_UGESTORA = FP.CD_UGESTORA AND C.CD_CARGO = FP.CD_CARGO)-- AND C.DT_MESANO = FP.DT_MESANO)
        ) AS CAR

    WHERE FP.MESANO_ORDENADO BETWEEN @DT_INICIAL AND @DT_FINAL
        AND FP.cd_UGestora = @UGESTORA
        AND FP.MESANO_ORDENADO + '01' > O.Obito

    GROUP BY
        PF.Nome
        ,O.Falecido
        ,O.Falecido
        ,FP.cd_CPF
        ,FP.nu_Matricula
        ,CAR.de_Cargo
        ,FP.dt_MesAno
        ,FP.MESANO_ORDENADO
        ,CAR.de_TipoCargo
        ,O.Obito

    UNION ALL

    SELECT 
        PF.Nome as nome
        ,O.Falecido as nomeFalecido
        ,FP.cd_CPF AS cpf
        ,FP.nu_Matricula AS servidor
        ,CAR.de_Cargo AS cargo
        ,FP.MESANO_ORDENADO AS mesAno
        ,O.Obito AS dataObito
        ,DATEDIFF(M,O.OBITO,FP.MESANO_ORDENADO + '01') AS mesesFalecido
        ,CAR.de_TipoCargo AS Natureza
        ,SUM(
            CASE
                WHEN FP.tp_Lancamento = 0 THEN FP.vl_Lancamento
                ELSE 0
            END
        ) AS remuneracaoBruta
        ,SUM(
            CASE
                WHEN FP.tp_Lancamento = 1 THEN FP.vl_Lancamento
                ELSE 0
            END
        ) AS descontos
        ,SUM(
            CASE
                WHEN FP.tp_Lancamento = 0 THEN FP.vl_Lancamento
                ELSE 0
            END
        )
        -
        SUM(
            CASE
                WHEN FP.tp_Lancamento = 1 THEN FP.vl_Lancamento
                ELSE 0
            END
        )
        AS remuneracaoLiquida
        ,'${nomenclaturas['fp_sisobi']}' as tipologia

    FROM SAGRES_MUNICIPAL.dbo.FolhaPagamento_N_2017 FP
        LEFT OUTER JOIN ReceitaNovo.dbo.PessoaFisica PF ON (PF.CPF = FP.cd_CPF)
        LEFT OUTER JOIN Sisobi.dbo.Obito O ON (FP.cd_CPF = O.CPF_RF)

        CROSS APPLY(
            SELECT TOP 1 C.DE_CARGO, TC.DE_TIPOCARGO
            FROM SAGRES_MUNICIPAL.dbo.Cargos_2017 C
            INNER JOIN SAGRES_MUNICIPAL.dbo.Tipo_Cargo TC ON (TC.TP_CARGO = C.TP_CARGO)
            WHERE (C.CD_UGESTORA = FP.CD_UGESTORA AND C.CD_CARGO = FP.CD_CARGO)-- AND C.DT_MESANO = FP.DT_MESANO)
        ) AS CAR

    WHERE FP.MESANO_ORDENADO BETWEEN @DT_INICIAL AND @DT_FINAL
        AND FP.cd_UGestora = @UGESTORA
        AND FP.MESANO_ORDENADO + '01' > O.Obito

    GROUP BY
        PF.Nome
        ,O.Falecido
        ,FP.cd_CPF
        ,FP.nu_Matricula
        ,CAR.de_Cargo
        ,FP.dt_MesAno
        ,FP.MESANO_ORDENADO
        ,CAR.de_TipoCargo
        ,O.Obito
        
    ) AS RESULTADO
--WHERE SOUNDEX(RESULTADO.nome) = SOUNDEX(RESULTADO.nomeFalecido)
WHERE RESULTADO.nome = RESULTADO.nomeFalecido
ORDER BY nome, mesAno DESC