-- TIPOLOGIA
--
-- Lista os servidores do órgão que tenham PJ.
-- Apresenta o numero de PJ por microrregiões.

DECLARE @DT_INICIAL VARCHAR(6), @DT_FINAL VARCHAR(6), @UGESTORA INT

SET @DT_INICIAL = '201601'
SET @DT_FINAL   = '201703'
SET @UGESTORA   = 101095

;WITH SERVIDORES(CPF)  --SELECIONA OS CPFS DOS FUNCIONÁRIOS DO ORGÃO ANALISADO
AS
(
    SELECT DISTINCT *
    FROM (
        SELECT FP.cd_CPF
        FROM SAGRES_MUNICIPAL.dbo.FolhaPagamento_N FP
        WHERE FP.cd_UGestora = @UGESTORA
            AND FP.MESANO_ORDENADO BETWEEN @DT_INICIAL AND @DT_FINAL

        UNION ALL

        SELECT FP_2017.cd_CPF
        FROM SAGRES_MUNICIPAL.dbo.FolhaPagamento_N_2017 FP_2017
        WHERE FP_2017.cd_UGestora = @UGESTORA
            AND FP_2017.MESANO_ORDENADO BETWEEN @DT_INICIAL AND @DT_FINAL
    ) AS RESULTADO
)
,PJ_SERVIDORES(CPF, CNPJ, Municipio, UF)  --LISTA AS PJ DE CADA UM DOS SERVIDORES
AS
(
    SELECT DISTINCT S.CpfSocio, PJ.CNPJ, PJ.Municipio,  PJ.UF
    FROM ReceitaNovo.dbo.Socio S
        INNER JOIN SERVIDORES SERV ON (('000' + SERV.CPF) = S.CpfSocio)
        INNER JOIN ReceitaNovo.dbo.PessoaJuridica PJ ON (PJ.CNPJ = S.Cnpj)
)
,TABELA3(CPF, MICROREGIAO, MUNICIPIO, UF, QTDE) -- LISTA OS CPFS DOS SERVIDORES E A QUANTIDADE DE PJ POR MICRORREGIAO
AS
(
    SELECT PJ_SERVIDORES.CPF, MMM.MICROREGIAO, PJ_SERVIDORES.Municipio, PJ_SERVIDORES.UF, COUNT(1) AS QTDE
    FROM PJ_SERVIDORES
        LEFT OUTER JOIN SISPESQUISA.dbo.MUNICIPIO_MESOMICROREGIAO MMM ON (MMM.MUNICIPIO = PJ_SERVIDORES.MUNICIPIO AND PJ_SERVIDORES.UF = 'PB')
    GROUP BY PJ_SERVIDORES.CPF, MMM.MICROREGIAO, PJ_SERVIDORES.Municipio, PJ_SERVIDORES.UF
)

SELECT 
    RIGHT(T3.CPF, 11) AS cpf,
    PF.Nome AS nome,
    CASE 
        WHEN ISNULL(T3.MICROREGIAO,'1') = '1' THEN T3.MUNICIPIO 
        ELSE T3.MICROREGIAO
    END AS microrregiaoPJ,
    CASE 
        WHEN ISNULL(T3.MICROREGIAO,'1') = '1' THEN T3.UF
        ELSE NULL
    END AS ufPJ,
    CASE 
        WHEN ISNULL(T3.MICROREGIAO,'1') = '1' THEN 'S'
        ELSE 'N'
    END AS foraEstado,
    T3.QTDE AS qtd,
    TAB.MICROREGIAO AS microrregiaoAnalise,
    CASE
        WHEN T3.MICROREGIAO =  TAB.MICROREGIAO THEN 1
        WHEN T3.MICROREGIAO <> TAB.MICROREGIAO AND ISNULL(T3.MICROREGIAO,'1') <> '1' THEN 2
        ELSE 3
    END AS peso
FROM TABELA3 T3
    LEFT OUTER JOIN ReceitaNovo.dbo.PessoaFisica PF ON (PF.CPF = RIGHT(T3.CPF, 11))

OUTER APPLY(
    SELECT DISTINCT MMM2.MICROREGIAO
    FROM SISPESQUISA.dbo.MUNICIPIO_MESOMICROREGIAO MMM2
    INNER JOIN SAGRES_CONTROLE.dbo.Codigo_Ugestora CU2 ON (CAST(LEFT(CU2.cd_Ibge,7) AS INT) = MMM2.CD_IBGE)
    WHERE CU2.cd_Ugestora = @UGESTORA
) AS TAB

ORDER BY 1, 2