DECLARE @DT_INICIAL VARCHAR(6), @DT_FINAL VARCHAR(6), @UGESTORA INT

SET @DT_INICIAL  = '201301'
SET @DT_FINAL    = '201703'
SET @UGESTORA    = 101020


;WITH SERVIDORES_DO_ORGAO(CPF, ANO) --SELECIONA OS CPFS DOS FUNCIONÁRIOS DO ORGÃO ANALISADO
AS
(    
    SELECT DISTINCT FP.cd_CPF, FP.dt_Ano
    FROM SAGRES_MUNICIPAL.dbo.FolhaPagamento_N FP
    WHERE FP.cd_UGestora = @UGESTORA
        AND FP.MESANO_ORDENADO BETWEEN @DT_INICIAL AND @DT_FINAL

    UNION ALL

    SELECT DISTINCT FP.cd_CPF, FP.dt_Ano
    FROM SAGRES_MUNICIPAL.dbo.FolhaPagamento_N_2017 FP
    WHERE FP.cd_UGestora = @UGESTORA
        AND FP.MESANO_ORDENADO BETWEEN @DT_INICIAL AND @DT_FINAL   
)
,
UG(CD_UGESTORA, CD_IBGE)
AS
(
    SELECT T.CD_UGESTORA, TAB.CD_IBGE
    FROM
        (
            SELECT DISTINCT CD_UGESTORA
            FROM SAGRES_CONTROLE.DBO.CODIGO_UGESTORA UG
            WHERE CD_UGESTORA NOT IN(
                900000, --	PARAÍBA
                999999	--Versão de Demonstração
            )
        ) AS T
        CROSS APPLY (
            SELECT TOP 1 de_Ugestora, cd_Ibge
            FROM SAGRES_CONTROLE.DBO.CODIGO_UGESTORA UG2
            WHERE T.cd_Ugestora = UG2.cd_Ugestora
            ORDER BY UG2.cd_Ibge DESC
        ) TAB
)
,SERVIDORES_COM_EXTRA_VINCULO(CPF, ANO, UGESTORA, CD_IBGE)  -- LISTA OS SERVIDORES QUE TENHAM VINCULO A UM ORGAO DIVERSO AO ORGAO ANALISADO
                                                            -- NO PERIODO DA ANALISE
                                                            -- SELECIONA OS CD_IBGE DE TODOS OS MUNICÍPIOS E O CPF DO SERVIDOR
AS
(    
    SELECT DISTINCT FP.cd_CPF, FP.dt_Ano, FP.cd_UGestora, LEFT(UG.cd_Ibge,7) AS CD_IBGE
    FROM SAGRES_MUNICIPAL.dbo.FolhaPagamento_N FP
        INNER JOIN SERVIDORES_DO_ORGAO SERV ON (SERV.CPF = FP.cd_CPF AND SERV.ANO = FP.dt_Ano)
        INNER JOIN UG ON (UG.CD_UGESTORA = FP.cd_UGestora)
        
    WHERE FP.CD_UGESTORA <> @UGESTORA  --NÃO LISTAR O REGISTRO REFERENTE A PRÓPRIA UNIDADE GESTORA QUE ESTÁ SENDO ANALISADA
        AND FP.MESANO_ORDENADO BETWEEN @DT_INICIAL AND @DT_FINAL	

    UNION ALL

    SELECT DISTINCT FP.cd_CPF, FP.dt_Ano, FP.cd_UGestora, LEFT(UG.cd_Ibge,7) AS CD_IBGE
    FROM SAGRES_MUNICIPAL.dbo.FolhaPagamento_N_2017 FP
        INNER JOIN SERVIDORES_DO_ORGAO SERV ON (SERV.CPF = FP.cd_CPF AND SERV.ANO = FP.dt_Ano)
        INNER JOIN UG ON (UG.CD_UGESTORA = FP.cd_UGestora)
        
    WHERE FP.CD_UGESTORA <> @UGESTORA  --NÃO LISTAR O REGISTRO REFERENTE A PRÓPRIA UNIDADE GESTORA QUE ESTÁ SENDO ANALISADA
        AND FP.MESANO_ORDENADO BETWEEN @DT_INICIAL AND @DT_FINAL	
),

SERVIDORES_EXTRA_VINCULOS_POR_MICRORREGIAO(CPF, MICROREGIAO, QTDE)	-- LISTA OS SERVIDORES QUE TENHAM VINCULO A UM ORGAO DIVERSO AO ORGAO ANALISADO
                                                                    -- NO PERIODO DA ANALISE
                                                                    -- SELECIONA A QUANTIDADE E A MICRORREGIAO DESSES EXTRAVINCULOS
AS
(
    SELECT SERV.CPF, MMM.MICROREGIAO, COUNT(1) AS QTDE
    FROM SERVIDORES_COM_EXTRA_VINCULO SERV
        INNER JOIN SISPESQUISA.dbo.MUNICIPIO_MESOMICROREGIAO MMM ON (MMM.CD_IBGE = SERV.CD_IBGE)	
    GROUP BY SERV.CPF, MMM.MICROREGIAO
)

SELECT 
    S.CPF AS cpf, 
    S.MICROREGIAO AS microrregiaoExtraVinculo, 
    S.QTDE AS qtdExtraVinculo, 
    TAB.MICROREGIAO AS microrregiaoAnalise,
    CASE
        WHEN S.MICROREGIAO =  TAB.MICROREGIAO THEN 1
        ELSE 2
    END AS peso

FROM SERVIDORES_EXTRA_VINCULOS_POR_MICRORREGIAO S

    CROSS APPLY(
        SELECT DISTINCT MMM2.MICROREGIAO
        FROM SISPESQUISA.dbo.MUNICIPIO_MESOMICROREGIAO MMM2
        INNER JOIN SAGRES_CONTROLE.dbo.Codigo_Ugestora CU2 ON (CAST(LEFT(CU2.cd_Ibge,7) AS INT) = MMM2.CD_IBGE)
        WHERE CU2.cd_Ugestora = @UGESTORA
    ) AS TAB
ORDER BY 2

--SELECT * 
--FROM SERVIDORES_COM_EXTRA_VINCULO