-- TIPOLOGIA
--
-- Lista os servidores que receberam pagamentos pela folha do órgão após sua 
-- data de óbito.

DECLARE @DT_INICIAL CHAR(8), @DT_FINAL CHAR(8), @UGESTORA INT, @CPF CHAR(11)

SET @DT_INICIAL = '20141101'
SET @DT_FINAL   = '20170201'
SET @UGESTORA   = '201095'

SELECT DISTINCT *
FROM (
    SELECT PF.Nome AS nome, O.Falecido as nomeFalecido, FP.cd_CPF AS cpf, CAST(O.Obito as date) AS dataObito --, '${nomenclaturas['fp_sisobi']}' as tipologia
    FROM SAGRES_MUNICIPAL.dbo.FolhaPagamento_N FP
        LEFT OUTER JOIN ReceitaNovo.dbo.PessoaFisica PF ON (PF.CPF = FP.cd_CPF )
        LEFT OUTER JOIN Sisobi.dbo.Obito O ON (FP.cd_CPF = O.CPF_RF)

    WHERE FP.MESANO_ORDENADO BETWEEN @DT_INICIAL AND @DT_FINAL
        AND FP.cd_UGestora = @UGESTORA
        AND FP.MESANO_ORDENADO+'01' > O.Obito
        --AND PF.Nome = O.Falecido

    GROUP BY PF.Nome, O.Falecido, FP.cd_CPF, O.Obito

    UNION ALL

    SELECT PF.Nome AS nome, O.Falecido as nomeFalecido, FP.cd_CPF AS cpf, CAST(O.Obito as date) AS dataObito --, '${nomenclaturas['fp_sisobi']}' as tipologia
    FROM SAGRES_MUNICIPAL.dbo.FolhaPagamento_N_2017 FP
        LEFT OUTER JOIN ReceitaNovo.dbo.PessoaFisica PF ON (PF.CPF = FP.cd_CPF )
        LEFT OUTER JOIN Sisobi.dbo.Obito O ON (FP.cd_CPF = O.CPF_RF)

    WHERE FP.MESANO_ORDENADO BETWEEN @DT_INICIAL AND @DT_FINAL
        AND FP.cd_UGestora = @UGESTORA
        AND FP.MESANO_ORDENADO+'01' > O.Obito
        --AND PF.Nome = O.Falecido

    GROUP BY PF.Nome, O.Falecido, FP.cd_CPF, O.Obito
) AS RESULTADO
ORDER BY 1