-- TIPOLOGIA
--
-- Lista os CPFs encontrados no cruzamento entre os Empenhos Pagos e o SISOBI.
--
-- A regra utilizada foi de listar aqueles que fecharam empenho depois de falecidos, ou seja,
-- com data de empenho após a data de óbito.

DECLARE @UGESTORA CHAR(6), @DT_INICIAL CHAR(8), @DT_FINAL CHAR(8) 

--    JP       BAYEUX     AGUA BRANCA
-- '101095' --'101025' --'101001'
-- '201095'

SET @UGESTORA   = '201025'
SET @DT_INICIAL = '20080101'
SET @DT_FINAL   = '20170401'

SELECT
    RIGHT(E.cd_Credor,11) as cpf,
    E.no_Credor as nome,
    O.Falecido as nomeFalecido,
    E.de_Historico as descricaoEmpenho,
	L.de_TipoLicitacao as descLicitacao,
    E.nu_Empenho as numEmpenho,
    E.dt_Empenho as dataEmpenho,
    P.dt_Pagamento AS dataPagamento,
    E.vl_Empenho as vlEmpenho,
    P.vl_Pagamento as vlPagamento,
    O.Obito as dataObito,
    DATEDIFF(M,O.OBITO,E.dt_Empenho) AS mesesFalecido

FROM SAGRES_MUNICIPAL.dbo.Empenhos E
    INNER JOIN SAGRES_MUNICIPAL.dbo.PAGAMENTOS P ON (E.cd_Ugestora = P.cd_Ugestora) AND (E.dt_Ano = P.dt_Ano) AND (E.cd_UnidOrcamentaria = P.cd_UnidOrcamentaria) AND (E.nu_Empenho = P.nu_Empenho)
    INNER JOIN Sisobi.dbo.Obito O ON  (RIGHT(E.cd_Credor, 11) = O.CPF_RF)
	LEFT OUTER JOIN SAGRES_MUNICIPAL.dbo.Tipo_Modalidade_Licitacao L ON (E.tp_Licitacao = L.tp_Licitacao)

WHERE E.cd_UGestora = @UGESTORA
    AND E.MESANO_ORDENADO BETWEEN @DT_INICIAL AND @DT_FINAL
    AND E.tp_Credor = 1 -- CREDOR PESSOA FISICA
    AND E.dt_Empenho > O.Obito	-- EMPENHADO POS MORTE
    AND O.CPF_RF <> '00000000000' -- CPF INVALIDO
    AND E.cd_Credor <> '00000000000191' -- CPF INVALIDO

GROUP BY 
    E.cd_Credor,
    E.no_Credor,
    E.de_Historico,
	L.de_TipoLicitacao,
    E.nu_Empenho,
    E.dt_Empenho,
    E.vl_Empenho,
    P.vl_Pagamento,
    P.dt_MesAno,
    P.dt_Pagamento,
    O.CPF_RF,
    O.Falecido,
    O.Obito

ORDER BY cpf, dataEmpenho DESC