-- TIPOLOGIA
--
-- Lista os servidores do órgão que sejam responsáveis por PJ.
-- Gera um score baseado na quantidade e distancia das empresas
-- para a unidade gestora.

DECLARE @DT_INICIAL VARCHAR(6), @DT_FINAL VARCHAR(6), @UGESTORA INT, @PESO_TIPOLOGIA INT

SET @PESO_TIPOLOGIA = 2
SET @DT_INICIAL     = '201001'
SET @DT_FINAL       = '201703'
SET @UGESTORA       = 101095

;WITH SERVIDORES(CPF)  --SELECIONA OS CPFS DOS FUNCIONÁRIOS DO ORGÃO ANALISADO
AS
(   
    SELECT DISTINCT FP.cd_CPF
    FROM SAGRES_MUNICIPAL.dbo.FolhaPagamento_N FP
    WHERE FP.cd_UGestora = @UGESTORA
        AND FP.MESANO_ORDENADO BETWEEN @DT_INICIAL AND @DT_FINAL

    UNION ALL

    SELECT DISTINCT FP.cd_CPF
    FROM SAGRES_MUNICIPAL.dbo.FolhaPagamento_N_2017 FP
    WHERE FP.cd_UGestora = @UGESTORA
        AND FP.MESANO_ORDENADO BETWEEN @DT_INICIAL AND @DT_FINAL   
)

,UG(CD_UGESTORA, MUNICIPIO, MICROREGIAO)
AS
(
    SELECT DISTINCT G.cd_Ugestora, M.no_Municipio, MMM.MICROREGIAO
    FROM SAGRES_CONTROLE.dbo.Codigo_Ugestora G
        INNER JOIN SAGRES_CONTROLE.dbo.Codigo_Municipios M ON (G.cd_Municipio = M.cd_Municipio)
        LEFT OUTER JOIN SISPESQUISA.dbo.MUNICIPIO_MESOMICROREGIAO MMM ON (MMM.MUNICIPIO COLLATE Latin1_General_CI_AI = M.no_Municipio COLLATE Latin1_General_CI_AI)	
)

,SERVIDORES_RESPONSAVEIS_EMPRESA(CPF, CNPJ, RAZAOSOCIAL, MUNICIPIO, UF, MICRORREGIAO, CUSTO)  
AS
(
    SELECT DISTINCT 
        SERV.CPF, PJ.CNPJ, PJ.RazaoSocial, PJ.Municipio,  PJ.UF, MMM.MICROREGIAO, 
        CASE
            WHEN ISNULL(CUSTO.custo, -1) = -1 THEN 20
            ELSE Custo.custo + 1
        END as custo
    FROM ReceitaNovo.dbo.PessoaJuridica PJ
        INNER JOIN SERVIDORES SERV ON (SERV.CPF = PJ.CpfResponsavel)
        LEFT OUTER JOIN SISPESQUISA.dbo.MUNICIPIO_MESOMICROREGIAO MMM ON (MMM.MUNICIPIO = PJ.MUNICIPIO AND PJ.UF = 'PB')
        LEFT OUTER JOIN UG ON (UG.CD_UGESTORA = @UGESTORA)
        LEFT OUTER JOIN SISPESQUISA.dbo.tabela_custo_microregioes CUSTO ON (CUSTO.origem = MMM.MICROREGIAO COLLATE Latin1_General_CI_AI AND CUSTO.destino = UG.MICROREGIAO COLLATE Latin1_General_CI_AI)
)

SELECT CPF as cpf, CNPJ as cnpj, RAZAOSOCIAL as razaoSocial, MUNICIPIO as municipio, UF as uf, MICRORREGIAO as microrregiao, CUSTO * @PESO_TIPOLOGIA as custo 
FROM SERVIDORES_RESPONSAVEIS_EMPRESA
ORDER BY CPF, CUSTO DESC
