-- TIPOLOGIA
--
-- Lista os servidores que receberam pagamentos pela folha do órgão após sua 
-- data de óbito.

DECLARE @DT_INICIAL VARCHAR(6), @DT_FINAL VARCHAR(6), @UGESTORA INT, @PESO_TIPOLOGIA INT

SET @PESO_TIPOLOGIA = 2
SET @DT_INICIAL     = '201201'
SET @DT_FINAL       = '201703'
SET @UGESTORA       = 201095

;WITH FOLHA_PAGAMENTO_FALECIDOS(CPF, NOME, NOMEFALECIDO, ANO, MESANO, DATAOBITO, MESESFALECIDO, MATRICULA, REMUNERACAOBRUTA, DESCONTOS, REMUNERACAOLIQUIDA)  --SELECIONA OS CPFS DOS FUNCIONÁRIOS DO ORGÃO ANALISADO
AS
(   
    SELECT	FP.cd_CPF, PF.Nome, O.Falecido, FP.dt_Ano, FP.MESANO_ORDENADO, O.Obito, 
            DATEDIFF(M, O.Obito, FP.MESANO_ORDENADO + '01'), FP.nu_Matricula,
            SUM(CASE
                    WHEN FP.tp_Lancamento = 0 THEN FP.vl_Lancamento
                    ELSE 0
                END
            ) AS remuneracaoBruta
            ,SUM(CASE
                     WHEN FP.tp_Lancamento = 1 THEN FP.vl_Lancamento
                     ELSE 0
                END
            ) AS descontos
            ,SUM(CASE
                    WHEN FP.tp_Lancamento = 0 THEN FP.vl_Lancamento
                    ELSE 0
                END
            ) - SUM(CASE
                        WHEN FP.tp_Lancamento = 1 THEN FP.vl_Lancamento
                        ELSE 0
                    END
            ) AS remuneracaoLiquida

    FROM SAGRES_MUNICIPAL.dbo.FolhaPagamento_N FP
        INNER JOIN ReceitaNovo.dbo.PessoaFisica PF ON (PF.CPF = FP.cd_CPF)
        INNER JOIN Sisobi.dbo.Obito O ON (FP.cd_CPF = O.CPF_RF)

    WHERE FP.cd_UGestora = @UGESTORA
        AND FP.MESANO_ORDENADO BETWEEN @DT_INICIAL AND @DT_FINAL
        AND FP.MESANO_ORDENADO + '01' > O.Obito

    GROUP BY FP.cd_CPF, PF.Nome, O.Falecido, FP.dt_Ano, FP.MESANO_ORDENADO, O.Obito, FP.nu_Matricula

    UNION

    SELECT	FP.cd_CPF, PF.Nome, O.Falecido, FP.dt_Ano, FP.MESANO_ORDENADO, O.Obito, 
            DATEDIFF(M, O.Obito, FP.MESANO_ORDENADO + '01'), FP.nu_Matricula,
            SUM(CASE
                    WHEN FP.tp_Lancamento = 0 THEN FP.vl_Lancamento
                    ELSE 0
                END
            ) AS remuneracaoBruta
            ,SUM(CASE
                     WHEN FP.tp_Lancamento = 1 THEN FP.vl_Lancamento
                     ELSE 0
                END
            ) AS descontos
            ,SUM(CASE
                    WHEN FP.tp_Lancamento = 0 THEN FP.vl_Lancamento
                    ELSE 0
                END
            ) - SUM(CASE
                        WHEN FP.tp_Lancamento = 1 THEN FP.vl_Lancamento
                        ELSE 0
                    END
            ) AS remuneracaoLiquida

    FROM SAGRES_MUNICIPAL.dbo.FolhaPagamento_N_2017 FP
        INNER JOIN ReceitaNovo.dbo.PessoaFisica PF ON (PF.CPF = FP.cd_CPF)
        INNER JOIN Sisobi.dbo.Obito O ON (FP.cd_CPF = O.CPF_RF)

    WHERE FP.cd_UGestora = @UGESTORA
        AND FP.MESANO_ORDENADO BETWEEN @DT_INICIAL AND @DT_FINAL
        AND FP.MESANO_ORDENADO + '01' > O.Obito

    GROUP BY FP.cd_CPF, PF.Nome, O.Falecido, FP.dt_Ano, FP.MESANO_ORDENADO, O.Obito, FP.nu_Matricula
)


SELECT	CPF as cpf, NOME as nome, NOMEFALECIDO as nomeFalecido, ANO as ano, MESANO as mesAno, DATAOBITO as dataObito, MESESFALECIDO as mesesFalecido,
        MATRICULA as matricula, REMUNERACAOBRUTA as remuneracaoBruta, DESCONTOS as descontos, REMUNERACAOLIQUIDA as remuneracaoLiquida
FROM FOLHA_PAGAMENTO_FALECIDOS
ORDER BY CPF, MESANO