-- TIPOLOGIA
-- 

DECLARE @DT_INICIAL VARCHAR(6) = '201501', @DT_FINAL VARCHAR(6) = '201703', @UGESTORA INT = 101095, @PESO_TIPOLOGIA INT = 5

;WITH SERVIDORES(CPF, ANO)
AS
(   
    SELECT DISTINCT FP.cd_CPF, FP.dt_Ano
    FROM SAGRES_MUNICIPAL.dbo.FolhaPagamento_Servidores FP
    WHERE FP.cd_UGestora = @UGESTORA
        AND FP.MESANO_ORDENADO BETWEEN @DT_INICIAL AND @DT_FINAL
)

,BOLSA_FAMILIA(NIS, ANO)
AS
(
    SELECT NISTitular, 2014 as ANO FROM BolsaFamilia.dbo.VW_BolsaFamilia_PB_2014
        UNION
    SELECT NISTitular, 2015 as ANO FROM BolsaFamilia.dbo.VW_BolsaFamilia_PB_2015
        UNION
    SELECT NISTitular, 2016 as ANO FROM BolsaFamilia.dbo.VW_BolsaFamilia_PB_2016
)


SELECT S.CPF as cpf, PF.Nome as nome, @PESO_TIPOLOGIA * COUNT(*) as QTD
FROM SERVIDORES S
    INNER JOIN Cadastro_Unico.dbo.bloco_00 CAD ON (CAD.CPF = S.CPF)
    INNER JOIN BOLSA_FAMILIA BF ON (BF.NIS = CAD.NIS AND S.ANO = BF.ANO)
    LEFT OUTER JOIN ReceitaNovo.dbo.PessoaFisica PF ON (S.CPF = PF.CPF)
	INNER JOIN Renavam_2014.dbo.renavam_2016_08 R ON (S.CPF = R.NUMERO_DOCUMENTO_PROPRIETARIO)  
GROUP BY S.CPF, PF.NOME