-- TIPOLOGIA
-- 
-- Lista os servidores do órgão que tinham vínculos
-- no mercado privado enquanto servidores.

DECLARE @DT_INICIAL VARCHAR(6) = '201201', @DT_FINAL VARCHAR(6) = '201703', @UGESTORA INT = 201020, @PESO_TIPOLOGIA INT = 5

;WITH SERVIDORES(CPF, ANO)
AS
(   
    SELECT DISTINCT FP.cd_CPF, FP.dt_Ano
    FROM SAGRES_MUNICIPAL.dbo.FolhaPagamento_Servidores FP
    WHERE FP.cd_UGestora = @UGESTORA
        AND FP.MESANO_ORDENADO BETWEEN @DT_INICIAL AND @DT_FINAL
)

,SERVIDORES_COM_VINCULOS_PRIVADOS(CPF, ANO, QTD)
AS
(
    SELECT E.CPF, E.ANO, COUNT(DISTINCT E.CNPJCEI) AS QTD
    FROM SERVIDORES S
        INNER JOIN CAGED.dbo.Empregados E  ON (S.CPF = E.CPF AND S.ANO = E.Ano)
    GROUP BY E.CPF, E.ANO
)

SELECT CPF as cpf, SUM(QTD * @PESO_TIPOLOGIA) as score
FROM SERVIDORES_COM_VINCULOS_PRIVADOS
GROUP BY CPF
ORDER BY 2 DESC