-- TIPOLOGIA
--
-- Lista os servidores do órgão que apresentem residência declarada na
-- RF com microrregião diferente da microrregião de onde se encontra o
-- órgão.
--
-- Gera um score baseado na distância entre o município do endereço 
-- declarado na RF e o da unidade gestora.

DECLARE @DT_INICIAL VARCHAR(6) = '201201', @DT_FINAL VARCHAR(6) = '201703', @UGESTORA INT = 101025, @PESO_TIPOLOGIA INT = 2


-- ;WITH SERVIDORES(CPF)
-- AS
-- (   
--     SELECT DISTINCT FP.cd_CPF
--     FROM SAGRES_MUNICIPAL.dbo.FolhaPagamento_Servidores FP
--     WHERE FP.cd_UGestora = @UGESTORA
--         AND FP.MESANO_ORDENADO BETWEEN @DT_INICIAL AND @DT_FINAL   
-- )

-- ,UG(CD_UGESTORA, MUNICIPIO, MICROREGIAO)
-- AS
-- (
--     SELECT DISTINCT G.cd_Ugestora, M.no_Municipio, MMM.MICROREGIAO
--     FROM SAGRES_CONTROLE.dbo.Codigo_Ugestora G
--         INNER JOIN SAGRES_CONTROLE.dbo.Codigo_Municipios M ON (G.cd_Municipio = M.cd_Municipio)
--         LEFT OUTER JOIN SISPESQUISA.dbo.MUNICIPIO_MESOMICROREGIAO MMM ON (MMM.MUNICIPIO COLLATE Latin1_General_CI_AI = M.no_Municipio COLLATE Latin1_General_CI_AI)
-- )

-- ,ENDERECOS_SERVIDORES(CPF, NOME, S_MUNICIPIO, S_UF, S_MICRORREGIAO, UG_MICRORREGIAO, CUSTO)
-- AS
-- (
--     SELECT  S.CPF, PF.Nome, PF.Municipio, PF.UF, MMM.MICROREGIAO, UG.MICROREGIAO,
--             CASE
--                 WHEN ISNULL(CUSTO.custo, -1) = -1 THEN 20
--                 ELSE Custo.custo + 1
--             END as custo

--     FROM ReceitaNovo.dbo.PessoaFisica PF
--         INNER JOIN SERVIDORES S ON (PF.CPF = S.CPF)
--         LEFT OUTER JOIN SISPESQUISA.dbo.MUNICIPIO_MESOMICROREGIAO MMM ON (MMM.MUNICIPIO COLLATE Latin1_General_CI_AI = PF.MUNICIPIO AND PF.UF = 'PB')
--         LEFT OUTER JOIN UG ON (UG.CD_UGESTORA = @UGESTORA)
--         LEFT OUTER JOIN SISPESQUISA.dbo.tabela_custo_microregioes CUSTO ON (CUSTO.origem = MMM.MICROREGIAO COLLATE Latin1_General_CI_AI AND CUSTO.destino = UG.MICROREGIAO COLLATE Latin1_General_CI_AI)
--     WHERE CUSTO.custo > 0 OR CUSTO.custo IS NULL
-- )

-- SELECT CPF as cpf, NOME as nome, CUSTO * @PESO_TIPOLOGIA as score
-- FROM ENDERECOS_SERVIDORES
-- ORDER BY 3 DESC


-- V2

-- ;WITH SERVIDORES(CPF)
-- AS
-- (   
--     SELECT DISTINCT FP.cd_CPF
--     FROM SAGRES_MUNICIPAL.dbo.FolhaPagamento_Servidores FP
--     WHERE FP.cd_UGestora = @UGESTORA
--         AND FP.MESANO_ORDENADO BETWEEN @DT_INICIAL AND @DT_FINAL   
-- )

-- ,UG(CD_UGESTORA, MUNICIPIO, MICROREGIAO)
-- AS
-- (
--     SELECT DISTINCT G.cd_Ugestora, M.no_Municipio, MMM.MICROREGIAO
--     FROM SAGRES_CONTROLE.dbo.Codigo_Ugestora G
--         INNER JOIN SAGRES_CONTROLE.dbo.Codigo_Municipios M ON (G.cd_Municipio = M.cd_Municipio)
--         LEFT OUTER JOIN SISPESQUISA.dbo.MUNICIPIO_MESOMICROREGIAO MMM ON (MMM.MUNICIPIO COLLATE Latin1_General_CI_AI = M.no_Municipio COLLATE Latin1_General_CI_AI)
-- )
-- ,ENDERECOS_SERVIDORES(CPF, NOME, S_MUNICIPIO, S_UF, UG_MUNICIPIO, CUSTO)
-- AS
-- (
    
-- SELECT  S.CPF, PF.Nome, PF.Municipio, PF.UF, UPPER(UG.Municipio),
--         CASE
--             WHEN ISNULL(CUSTO.DISTANCIA_M, -1) = -1 THEN -1
--             ELSE Custo.DISTANCIA_M
--         END as custo

-- FROM ReceitaNovo.dbo.PessoaFisica PF
--     INNER JOIN SERVIDORES S ON (PF.CPF = S.CPF)
--     LEFT OUTER JOIN SISPESQUISA.dbo.MUNICIPIO_MESOMICROREGIAO MMM ON (MMM.MUNICIPIO COLLATE Latin1_General_CI_AI = PF.MUNICIPIO AND PF.UF = 'PB')
--     LEFT OUTER JOIN UG ON (UG.CD_UGESTORA = @UGESTORA)
-- 	LEFT OUTER JOIN SISPESQUISA.dbo.DISTANCIA_MUNICIPIOS CUSTO ON ((CUSTO.MUNICIPIO_ORIGEM COLLATE Latin1_General_CI_AI = MMM.MUNICIPIO AND CUSTO.MUNICIPIO_DESTINO COLLATE Latin1_General_CI_AI = UG.MUNICIPIO) OR (CUSTO.MUNICIPIO_DESTINO COLLATE Latin1_General_CI_AI = MMM.MUNICIPIO AND CUSTO.MUNICIPIO_ORIGEM COLLATE Latin1_General_CI_AI = UG.MUNICIPIO))
-- WHERE(PF.Municipio <> UG.Municipio COLLATE Latin1_General_CI_AI)
-- )

-- SELECT CPF as cpf, NOME as nome, S_MUNICIPIO, S_UF, UG_MUNICIPIO, CUSTO as score
-- FROM ENDERECOS_SERVIDORES
-- WHERE CUSTO > 30000 OR CUSTO = -1
-- ORDER BY score DESC

-- V3

;WITH SERVIDORES(CPF)
AS
(   
    SELECT DISTINCT FP.cd_CPF
    FROM SAGRES_MUNICIPAL.dbo.FolhaPagamento_Servidores FP
    WHERE FP.cd_UGestora = @UGESTORA
        AND FP.MESANO_ORDENADO BETWEEN @DT_INICIAL AND @DT_FINAL   
)
,UG(CD_UGESTORA, MUNICIPIO, MICROREGIAO)
AS
(
    SELECT DISTINCT G.cd_Ugestora, M.no_Municipio, MMM.MICROREGIAO
    FROM SAGRES_CONTROLE.dbo.Codigo_Ugestora G
        INNER JOIN SAGRES_CONTROLE.dbo.Codigo_Municipios M ON (G.cd_Municipio = M.cd_Municipio)
        LEFT OUTER JOIN SISPESQUISA.dbo.MUNICIPIO_MESOMICROREGIAO MMM ON (MMM.MUNICIPIO COLLATE Latin1_General_CI_AI = M.no_Municipio COLLATE Latin1_General_CI_AI)
)
,ENDERECOS_SERVIDORES(CPF, NOME, S_MUNICIPIO, S_UF, UG_MUNICIPIO, CUSTO)
AS
(
    
	SELECT  S.CPF, PF.Nome, PF.Municipio, PF.UF, UPPER(UG.Municipio), Custo.distancia
	FROM ReceitaNovo.dbo.PessoaFisica PF
		INNER JOIN SERVIDORES S ON (PF.CPF = S.CPF)
		LEFT OUTER JOIN UG ON (UG.CD_UGESTORA = @UGESTORA)
		LEFT OUTER JOIN SISPESQUISA.dbo.resultado CUSTO ON 
			((CUSTO.MUNICIPIO_ORIGEM COLLATE Latin1_General_CI_AI = UG.MUNICIPIO 
			AND CUSTO.MUNICIPIO_DESTINO COLLATE Latin1_General_CI_AI = PF.Municipio) 
			AND CUSTO.uf_origem = 'PB'
			AND CUSTO.uf_destino = PF.UF)
	WHERE(PF.Municipio <> UG.Municipio COLLATE Latin1_General_CI_AI)
)

SELECT CPF as cpf, NOME as nome, S_MUNICIPIO, S_UF, UG_MUNICIPIO, CUSTO as score
FROM ENDERECOS_SERVIDORES
WHERE CUSTO > 20 OR CUSTO IS NULL
order by score desc