-- TIPOLOGIA
-- 


DECLARE @DT_INICIAL VARCHAR(6) = '201201', @DT_FINAL VARCHAR(6) = '201703', @UGESTORA INT = 201095, @PESO_TIPOLOGIA INT = 5

;WITH SERVIDORES(CPF)
AS
(   
    SELECT DISTINCT FP.cd_CPF
    FROM SAGRES_MUNICIPAL.dbo.FolhaPagamento_Servidores FP
    WHERE FP.cd_UGestora = @UGESTORA
        AND FP.MESANO_ORDENADO BETWEEN @DT_INICIAL AND @DT_FINAL
)
,SERVIDOR_CONTAS_BANCARIAS(CPF, BANCO, AGENCIA, CONTA, DIGITO, DESCRICAO)
AS
(
    SELECT S.CPF as cpf, CC.banco, CC.agencia, CC.conta, CC.digito, CC.ds_conta
    FROM SERVIDORES S
        INNER JOIN SIAF.siaf.credores C ON (C.nu_cnpj_cpf = S.CPF)
        INNER JOIN SIAF.siaf.credores_contas CC ON (C.cd = CC.cd_credor)
)

,RESULTADO(CPF, BANCO, AGENCIA, CONTA, QTD)
AS
(
    SELECT S.CPF, S.BANCO, S.AGENCIA, S.CONTA, COUNT(cd_credor) AS QTD
    FROM SERVIDOR_CONTAS_BANCARIAS S
        INNER JOIN SIAF.siaf.credores_contas CC ON (CC.banco = S.BANCO AND CC.agencia = S.AGENCIA AND CC.conta = S.CONTA AND CC.digito = S.DIGITO)
    GROUP BY S.CPF, S.BANCO, S.AGENCIA, S.CONTA
)

SELECT CPF as cpf, QTD as score
FROM RESULTADO
WHERE QTD > 1