-- TIPOLOGIA
--

DECLARE @DT_INICIAL VARCHAR(6) = '201201', @DT_FINAL VARCHAR(6) = '201703', @UGESTORA INT = 101025, @PESO_TIPOLOGIA INT = 150

;WITH SERVIDORES(CPF)
AS
(   
    SELECT DISTINCT FP.cd_CPF
    FROM SAGRES_MUNICIPAL.dbo.FolhaPagamento_Servidores FP
    WHERE FP.cd_UGestora = @UGESTORA
        AND FP.MESANO_ORDENADO BETWEEN @DT_INICIAL AND @DT_FINAL
)

,UG(CD_UGESTORA, MUNICIPIO, MICROREGIAO)
AS
(
    SELECT DISTINCT G.cd_Ugestora, M.no_Municipio, MMM.MICROREGIAO
    FROM SAGRES_CONTROLE.dbo.Codigo_Ugestora G
        INNER JOIN SAGRES_CONTROLE.dbo.Codigo_Municipios M ON (G.cd_Municipio = M.cd_Municipio)
        LEFT OUTER JOIN SISPESQUISA.dbo.MUNICIPIO_MESOMICROREGIAO MMM ON (MMM.MUNICIPIO COLLATE Latin1_General_CI_AI = M.no_Municipio COLLATE Latin1_General_CI_AI)	
)

,SERVIDORES_SOCIOS(CPF, CNPJ, RAZAOSOCIAL, MUNICIPIO, UF, MICRORREGIAO, CUSTO)
AS
(
    SELECT DISTINCT 
        SERV.CPF, PJ.CNPJ, PJ.RazaoSocial, PJ.Municipio, PJ.UF, MMM.MICROREGIAO, 
        CASE
            WHEN ISNULL(CUSTO.custo, -1) = -1 THEN 20
            ELSE Custo.custo + 1
        END as custo

    FROM ReceitaNovo.dbo.Socio S
        INNER JOIN SERVIDORES SERV ON (('000' + SERV.CPF) = S.CpfSocio AND S.IdentificadorSocio = 2)
        INNER JOIN ReceitaNovo.dbo.PessoaJuridica PJ ON (PJ.CNPJ = S.Cnpj)
        LEFT OUTER JOIN SISPESQUISA.dbo.MUNICIPIO_MESOMICROREGIAO MMM ON (MMM.MUNICIPIO COLLATE Latin1_General_CI_AI = PJ.MUNICIPIO AND PJ.UF = 'PB')
        LEFT OUTER JOIN UG ON (UG.CD_UGESTORA = @UGESTORA)
        LEFT OUTER JOIN SISPESQUISA.dbo.tabela_custo_microregioes CUSTO ON (CUSTO.origem = MMM.MICROREGIAO COLLATE Latin1_General_CI_AI AND CUSTO.destino = UG.MICROREGIAO COLLATE Latin1_General_CI_AI)
)

,EMPRESAS_FUNCIONARIOS_CAGED(CPF, CNPJ, RAZAOSOCIAL, MUNICIPIO, UF, MICRORREGIAO, CUSTO, QTD_EMPREGADOS_CAGED)
AS
(
    SELECT S.CPF, S.CNPJ, S.RAZAOSOCIAL, S.MUNICIPIO, S.UF, S.MICRORREGIAO, 
            S.CUSTO, COUNT(DISTINCT E.CPF) as QTD_EMPREGADOS_CAGED
    FROM SERVIDORES_SOCIOS S
        LEFT OUTER JOIN CAGED.dbo.Empregados E ON (S.CNPJ = E.CNPJCEI)
    WHERE (E.Competencia BETWEEN @DT_INICIAL AND @DT_FINAL) OR E.Competencia IS NULL
    GROUP BY S.CPF, S.CNPJ, S.RAZAOSOCIAL, S.MUNICIPIO, S.UF, S.MICRORREGIAO, S.CUSTO

)

,RESULTADO(CPF, NOME, CUSTO, QTD_EMPRESAS_FANTASMAS)
AS
(	
    SELECT E.CPF, PF.Nome, CUSTO, COUNT(CNPJ)
    FROM EMPRESAS_FUNCIONARIOS_CAGED E
        INNER JOIN ReceitaNovo.dbo.PessoaFisica PF ON (PF.CPF = E.CPF)
    WHERE QTD_EMPREGADOS_CAGED = 0
    GROUP BY E.CPF, Pf.NOME, CUSTO
)

--,EMPRESAS_FUNCIONARIOS_RAIS(CPF, CNPJ, RAZAOSOCIAL, MUNICIPIO, UF, MICRORREGIAO, CUSTO, QTD_EMPREGADOS)
--AS
--(
--	SELECT CPF, CNPJ, RAZAOSOCIAL, MUNICIPIO, UF, MICRORREGIAO, CUSTO, SUM(R.QTD) AS QTD
--	FROM
--	(
--		SELECT S.CPF, S.CNPJ, S.RAZAOSOCIAL, S.MUNICIPIO, S.UF, S.MICRORREGIAO, S.CUSTO, COUNT(E.CPF) AS QTD
--		FROM SERVIDORES_SOCIOS S
--			LEFT OUTER JOIN RAIS.dbo.RAIS2011 E ON (S.CNPJ = E.[CNPJ   CEI])
--		WHERE @DT_INICIAL <= '201101' AND @DT_FINAL >= '201101'
--		GROUP BY S.CPF, S.CNPJ, S.RAZAOSOCIAL, S.MUNICIPIO, S.UF, S.MICRORREGIAO, S.CUSTO

--		--UNION

--		--SELECT S.CPF, S.CNPJ, S.RAZAOSOCIAL, S.MUNICIPIO, S.UF, S.MICRORREGIAO, S.CUSTO, COUNT(E.CPF) AS QTD
--		--FROM SERVIDORES_SOCIOS S
--		--	LEFT OUTER JOIN RAIS.dbo.RAIS2012 E ON (S.CNPJ = E.[CNPJ   CEI])
--		--WHERE @DT_INICIAL <= '201201' AND @DT_FINAL >= '201201'
--		--GROUP BY S.CPF, S.CNPJ, S.RAZAOSOCIAL, S.MUNICIPIO, S.UF, S.MICRORREGIAO, S.CUSTO

--		--UNION

--		--SELECT S.CPF, S.CNPJ, S.RAZAOSOCIAL, S.MUNICIPIO, S.UF, S.MICRORREGIAO, S.CUSTO, COUNT(E.CPF) AS QTD
--		--FROM SERVIDORES_SOCIOS S
--		--	LEFT OUTER JOIN RAIS.dbo.RAIS2013 E ON (S.CNPJ = E.[CNPJ   CEI])
--		--WHERE @DT_INICIAL <= '201301' AND @DT_FINAL >= '201301'
--		--GROUP BY S.CPF, S.CNPJ, S.RAZAOSOCIAL, S.MUNICIPIO, S.UF, S.MICRORREGIAO, S.CUSTO

--		--UNION

--		--SELECT S.CPF, S.CNPJ, S.RAZAOSOCIAL, S.MUNICIPIO, S.UF, S.MICRORREGIAO, S.CUSTO, COUNT(E.CPF) AS QTD
--		--FROM SERVIDORES_SOCIOS S
--		--	LEFT OUTER JOIN RAIS.dbo.RAIS2014 E ON (S.CNPJ = E.[CNPJ   CEI])
--		--WHERE @DT_INICIAL <= '201401' AND @DT_FINAL >= '201401'
--		--GROUP BY S.CPF, S.CNPJ, S.RAZAOSOCIAL, S.MUNICIPIO, S.UF, S.MICRORREGIAO, S.CUSTO

--		--UNION

--		--SELECT S.CPF, S.CNPJ, S.RAZAOSOCIAL, S.MUNICIPIO, S.UF, S.MICRORREGIAO, S.CUSTO, COUNT(E.CPF) AS QTD
--		--FROM SERVIDORES_SOCIOS S
--		--	LEFT OUTER JOIN RAIS.dbo.RAIS2015 E ON (S.CNPJ = E.[CNPJ   CEI])
--		--WHERE @DT_INICIAL <= '201501' AND @DT_FINAL >= '201501'
--		--GROUP BY S.CPF, S.CNPJ, S.RAZAOSOCIAL, S.MUNICIPIO, S.UF, S.MICRORREGIAO, S.CUSTO
--	) AS R
--	GROUP BY CPF, CNPJ, RAZAOSOCIAL, MUNICIPIO, UF, MICRORREGIAO, CUSTO
--)


--SELECT S.CPF, S.CNPJ, S.RAZAOSOCIAL, S.MUNICIPIO, S.UF, S.MICRORREGIAO, S.CUSTO,		
--			COUNT(E11.CPF) AS QTD_2011
--			--COUNT(E12.CPF) AS QTD_2012,
--			--COUNT(E13.CPF) AS QTD_2013,
--			--COUNT(E14.CPF) AS QTD_2014,
--			--COUNT(E15.CPF) AS QTD_2015			

--FROM SERVIDORES_SOCIOS S
--	LEFT OUTER JOIN RAIS.dbo.RAIS2011 E11 ON (S.CNPJ = E11.[CNPJ   CEI])
--	LEFT OUTER JOIN RAIS.dbo.RAIS2012 E12 ON (S.CNPJ = E12.[CNPJ   CEI])
--	LEFT OUTER JOIN RAIS.dbo.RAIS2013 E13 ON (S.CNPJ = E13.[CNPJ   CEI])
--	LEFT OUTER JOIN RAIS.dbo.RAIS2014 E14 ON (S.CNPJ = E14.[CNPJ   CEI])
--	LEFT OUTER JOIN RAIS.dbo.RAIS2015 E15 ON (S.CNPJ = E15.[CNPJ   CEI])
--GROUP BY S.CPF, S.CNPJ, S.RAZAOSOCIAL, S.MUNICIPIO, S.UF, S.MICRORREGIAO, S.CUSTO


SELECT CPF as cpf, NOME as nome, SUM((@PESO_TIPOLOGIA * QTD_EMPRESAS_FANTASMAS)/CUSTO) as score
FROM RESULTADO
GROUP BY CPF, NOME
ORDER BY score DESC