-- TIPOLOGIA
-- 
-- Lista os servidores do órgão que tenham
-- tipologias junto ao TCU.


DECLARE @DT_INICIAL VARCHAR(6) = '201201', @DT_FINAL VARCHAR(6) = '201703', @UGESTORA INT = 101020, @PESO_TIPOLOGIA INT = 5

;WITH SERVIDORES(CPF)
AS
(   
    SELECT DISTINCT FP.cd_CPF
    FROM SAGRES_MUNICIPAL.dbo.FolhaPagamento_Servidores FP
    WHERE FP.cd_UGestora = @UGESTORA
        AND FP.MESANO_ORDENADO BETWEEN @DT_INICIAL AND @DT_FINAL
)
, RESULTADO(CPF, NOME, FAIXA)
AS
(
    SELECT S.CPF as cpf, Credor as nome, 
        CASE
            WHEN T.DoacaoEleitoral < 5000 THEN 1
            WHEN T.DoacaoEleitoral >= 5000 AND T.DoacaoEleitoral < 10000 THEN 2
            WHEN T.DoacaoEleitoral >= 10000 AND T.DoacaoEleitoral < 50000 THEN 3
            WHEN T.DoacaoEleitoral >= 50000 AND T.DoacaoEleitoral < 100000 THEN 4
            WHEN T.DoacaoEleitoral >= 100000 AND T.DoacaoEleitoral < 500000 THEN 5
            WHEN T.DoacaoEleitoral >= 500000 AND T.DoacaoEleitoral < 1000000 THEN 6
            ELSE 7
        END as score

    FROM SERVIDORES S
        INNER JOIN Tipologias.dbo.MATRIZ_COMPLETA_PF T ON (S.CPF = T.CPF)
    WHERE T.T27 <> 0 OR T.T28 <> 0 OR T.T29 <> 0 OR T.T30 <> 0 OR T.T31 <> 0
)

SELECT CPF as cpf, NOME as nome, @PESO_TIPOLOGIA * FAIXA as score
FROM RESULTADO