-- TIPOLOGIA
-- 
-- Lista os servidores do órgão que tenham
-- tipologias junto ao TCU.


DECLARE @DT_INICIAL VARCHAR(6) = '201201', @DT_FINAL VARCHAR(6) = '201703', @UGESTORA INT = 101020, @PESO_TIPOLOGIA INT = 5

;WITH SERVIDORES(CPF)
AS
(   
    SELECT DISTINCT FP.cd_CPF
    FROM SAGRES_MUNICIPAL.dbo.FolhaPagamento_Servidores FP
    WHERE FP.cd_UGestora = @UGESTORA
        AND FP.MESANO_ORDENADO BETWEEN @DT_INICIAL AND @DT_FINAL
)

SELECT S.CPF as cpf, Credor as nome, TotalPesoTipologia * @PESO_TIPOLOGIA as score
FROM SERVIDORES S
    INNER JOIN Tipologias.dbo.MATRIZ_COMPLETA_PF T ON (S.CPF = T.CPF)
WHERE T.TotalOcorrencias > 0
