-- TIPOLOGIA
-- 
-- Lista os servidores do órgão que tenham veículos.
--
-- Gera um score baseado na quantidade e distancia de
-- veiculos por servidor.

DECLARE @DT_INICIAL VARCHAR(6) = '201501', @DT_FINAL VARCHAR(6) = '201703', @UGESTORA INT = 101095, @PESO_TIPOLOGIA INT = 5

;WITH SERVIDORES(CPF)
AS
(   
    SELECT DISTINCT FP.cd_CPF
    FROM SAGRES_MUNICIPAL.dbo.FolhaPagamento_Servidores FP
    WHERE FP.cd_UGestora = @UGESTORA
        AND FP.MESANO_ORDENADO BETWEEN @DT_INICIAL AND @DT_FINAL
)

,SERVIDORES_COM_CARROS(CPF, QTD)
AS
(
    SELECT S.CPF, COUNT(*) AS QTD 
    FROM Renavam_2014.dbo.renavam_2016_08 R
        INNER JOIN SERVIDORES S ON (S.CPF = R.NUMERO_DOCUMENTO_PROPRIETARIO)  
    GROUP BY CPF
)

SELECT CPF AS cpf, QTD AS qtd,
    CASE
        WHEN QTD <3 THEN 1
        WHEN QTD >=3 AND QTD < 5 THEN 2
        WHEN QTD >= 5 THEN 3
    END AS faixa
FROM SERVIDORES_COM_CARROS S
ORDER BY QTD DESC