import * as mssql from 'mssql';

import { connection }  from '../../services/db.service';
import { MODEL_PRIORITY, API_CONFIG } from '../../config';
import {
    resultNotFound,
    resultFound,
    logErroBuscaBD
} from '../../utils';

import { SIGLA_FONTE } from './../_fontes';

const fonte = MODEL_PRIORITY['sispesquisa.email'].fonte;
const rank  = MODEL_PRIORITY['sispesquisa.email'].rank;
const grupo = MODEL_PRIORITY['sispesquisa.email'].grupo;

export let getEmailCPF_SispesquisaEmail = function (cpf: string){

    return connection.getConn().request()
        .input('CPF', mssql.VarChar, cpf)
        .query(`SELECT TOP ${API_CONFIG.SIAP_MAX_RESULTS}
                    CPF_CNPJ as cpf
                    ,LOWER(EMAIL) AS email
                    ,'email' as tipo
                    ,fonte

                FROM SISPESQUISA.sispesquisa.emails
                WHERE CPF_CNPJ=@CPF
        `)
        .then(result => {
            if(result.recordset.length === 0)
                return resultNotFound(`Nao foi possivel encontrar o email de ${cpf}.`, fonte);
            else
                return resultFound(result, fonte, rank, grupo);
        }).catch(error => { return logErroBuscaBD(error, `Falha na busca pelo email de ${cpf}.`, 'getEmailCPF_SispesquisaEmail'); });
};