import { Router } from 'express';

import {
    GuardRotasPerfilPrivado,
    GuardRotasChecaHash,
    ControleAcessoGuard,
    GuardRotasLogado
} from '../../services/auth/authguard.service';

import {
    getQuestao,
    insertRespostasQuestionario
} from '../../controllers/riscomppb.controller';

import { mapeamentoItensAcesso as mpi } from '../../services/auth/controle.acesso';
import { mapeamentoSecoesAcesso as mps } from '../../services/auth/controle.acesso';

import { cache } from '../../services/apicache.service';

const risco: Router = Router();

/**
 * Protege a Rota para usuários que tenham um token válido e que tenham permissão 
 * para requisitar o item 'Risco' da seção 'Apps'
 */
risco.use(GuardRotasLogado, GuardRotasChecaHash);
// risco.use(ControleAcessoGuard({ secao: mps.apps, item: mpi.apps. }));

/**
 * Realiza o cache das rotas abaixo
 */
risco.use(cache.connect());

risco.get('/', getQuestao);
risco.post('/respostas', insertRespostasQuestionario);

export default risco;
