import { Router } from 'express';

import {
    GuardRotasPerfilAdmin,
    GuardRotasChecaHash
} from '../services/auth/authguard.service';

import {
    getPreUsuariosInativos,
    insertPreUsuarios,
    deletePreUsuario,
    ativarPreUsuario 
} from '../controllers/preusuarios.controller';

const preusuarios: Router = Router();

preusuarios.post('/', insertPreUsuarios);

preusuarios.use(GuardRotasPerfilAdmin, GuardRotasChecaHash);

preusuarios.get('/', getPreUsuariosInativos);
preusuarios.delete('/:id', deletePreUsuario);
preusuarios.post('/ativar/:id', ativarPreUsuario);

export default preusuarios;
