import { Router } from 'express';

import {
    GuardRotasPerfilAdmin,
    GuardRotasChecaHash
} from '../services/auth/authguard.service';

import { 
    listaUsuarios,
    getUsuario,
    getUsuarioMe,
    updateUsuario,
    updateSenhaUsuario,
    deleteUsuario,
    redefinirSenhaUsuario,
    atualizarControleAcessoUsuario,
    getControleAcessoUsuario,
} from '../controllers/usuarios.controller';

const usuarios: Router = Router();

usuarios.patch('/:id/trocasenha', updateSenhaUsuario);
usuarios.get('/me', getUsuarioMe);

// As outras rotas precisam de autorização para serem executadas
usuarios.use(GuardRotasPerfilAdmin, GuardRotasChecaHash);

usuarios.get('/', listaUsuarios);
usuarios.get('/:id', getUsuario);
usuarios.patch('/:id', updateUsuario);
usuarios.delete('/:id', deleteUsuario);
usuarios.patch('/:id/redefinirsenha', redefinirSenhaUsuario);

usuarios.get('/:id/controleacesso', getControleAcessoUsuario);
usuarios.patch('/:id/controleacesso', atualizarControleAcessoUsuario);


export default usuarios;

