import * as mssql from 'mssql';

import { connection }  from '../../services/db.service';
import { MODEL_PRIORITY, API_CONFIG } from '../../config';
import {
    resultNotFound,
    resultFound,
    logErroBuscaBD
} from '../../utils';

import { SIGLA_FONTE } from './../_fontes';

const fonte_dado = SIGLA_FONTE['dna.pj'];

const fonte = MODEL_PRIORITY['dna.pj.email'].fonte;
const rank  = MODEL_PRIORITY['dna.pj.email'].rank;
const grupo = MODEL_PRIORITY['dna.pj.email'].grupo;

export let getEmailCNPJ_DNA_PJ = function (cnpj: string){

    return connection.getConn().request()
        .input('CNPJ', mssql.VarChar, cnpj)
        .query(`SELECT TOP ${API_CONFIG.SIAP_MAX_RESULTS}
                    CNPJ as cnpj
                    ,LOWER(EMAIL) AS email
                    ,'email' as tipo
                    ,'${fonte_dado}' as fonte

                FROM DNA.dbo.PESSOA_JURIDICA
                WHERE CNPJ=@CNPJ
        `)
        .then(result => {
            if(result.recordset.length === 0)
                return resultNotFound(`Nao foi possivel encontrar o email de ${cnpj}.`, fonte);
            else
                return resultFound(result, fonte, rank, grupo);
        }).catch(error => { return logErroBuscaBD(error, `Falha na busca pelo email de ${cnpj}.`, 'getEmailCNPJ_DNA_PJ'); });
};